pthbs

Packaging Through Hashed Build Scripts
git clone https://ccx.te2000.cz/git/pthbs
Log | Files | Refs | Submodules | README

attr (3231B)


      1 #!/usr/bin/env pthbs-build
      2 #+musl-cross-make.65f98305f5666435bf0c6b9ccedffae2179ff1b3286752756886f760cf7771d2
      3 #+gnu-make.782c9e6625fd7420e2cd38b847afed19db3b3844cae8a0426a0dbf73e10d78e5
      4 #+busybox.e60885fe93ee85c01831673bb29f0e62a64903f4ce3094e3dc35bc8ec8887ad9
      5 #+busybox-diffutils.4f5a07b29246414b77a7d71b103263af8f1249d75ddcbd9864e00def3d6feded
      6 #+m4.d61a4ef6e5ca207e24ed8bbbd9931e1e0ac2359ed5aae4e384b49d71401b4840
      7 #@untar:-z:sha256:39bf67452fa41d0948c2197601053f48b3d78a029389734332a6309a680c6c87:.
      8 
      9 build_env_static() {
     10 	export LD_LIBRARY_PATH="$pthbs_build_environment/library"
     11 	export CPATH="$pthbs_build_environment/include"
     12 	export LDFLAGS="-static -L$pthbs_build_environment/library $LDFLAGS"
     13 }
     14 autotools_config() {
     15 	prefix=/versions/$pthbs_package
     16 	./configure -C \
     17 		--prefix="$prefix" \
     18 		--build="$(${CC:-gcc} -dumpmachine)" \
     19 		--bindir="$prefix/command" \
     20 		--sbindir="$prefix/command" \
     21 		--infodir="$prefix/info" \
     22 		--localedir="$prefix/locale" \
     23 		--mandir="$prefix/man" \
     24 		--libdir="$prefix/library" \
     25 		--docdir="$prefix/doc/attr" \
     26 		--datadir="$prefix/data" \
     27 		--datarootdir="$prefix/data" \
     28 		--localstatedir='/var/pthbs' \
     29 		"$@"
     30 
     31 }
     32 
     33 autotools() {
     34 	cd "$1"
     35 	shift
     36 	autotools_config "$@"
     37 	make -j${JOBS:-1} -l$((1+${JOBS:-1}))
     38 	make DESTDIR="$pthbs_destdir" install
     39 }
     40 
     41 autotools_static() {
     42 	build_env_static
     43 	autotools "$@" --enable-static --disable-shared
     44 }
     45 check_static() {
     46 	local exe || true
     47 	exe=$pthbs_destdir/'/versions'/$pthbs_package/$1
     48 	if ! test -f $exe; then
     49 		printf '%s\n' "Error: file '$1' doesn't exist!"
     50 		exit 1
     51 	fi
     52 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     53 	if test x '!=' "x$interp_info"; then
     54 		printf '%s\n' "Error: '$1' is a dynamic binary!"
     55 		exit 1
     56 	fi
     57 }
     58 
     59 
     60 LDFLAGS=--static
     61 autotools_static attr-2.5.2
     62 check_static command/attr
     63 
     64 
     65 
     66 cd "$pthbs_destdir/versions/$pthbs_package"
     67 find -type d -o -print | awk -F/ '
     68 BEGIN {
     69 	x["./command/attr"]=1
     70 	x["./command/setfattr"]=1
     71 	x["./command/getfattr"]=1
     72 	x["./library/libattr.a"]=1
     73 	x["./include/attr/libattr.h"]=1
     74 }
     75 
     76 function r1(s) {
     77 	sub("^[.]/[^/]*", ".", s)
     78 	return s
     79 }
     80 function s1(repl, s) {
     81 	sub("^[.]/[^/]*", "./"repl, s)
     82 	return s
     83 }
     84 function link(src) {
     85 	x[$0]=0
     86 	printf "%s\t%s\n", $0, src
     87 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
     88 }
     89 $1!="."{exit 1}
     90 
     91 
     92 $2 == "command" { link($0); next }
     93 $2 == "bin" { link(s1("command", $0)); next }
     94 
     95 $2 == "library.so" { link($0); next }
     96 $2 == "library" { link($0); next }
     97 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
     98 $2 == "lib" && $NF ~ /\.so(|\..*)$/ { link(s1("library.so", $0)); next }
     99 
    100 $2 == "share" && $3 ~ /^(info|man|doc|icons|terminfo)$/ { link(r1($0)); next }
    101 
    102 $2 == "man" { link($0); next }
    103 $2 == "info" { link($0); next }
    104 $2 == "doc" { link($0); next }
    105 $2 == "icons" { link($0); next }
    106 $2 == "terminfo" { link($0); next }
    107 $2 == "data" { link($0); next }
    108 $2 == "include" { link($0); next }
    109 
    110 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    111 
    112 END {
    113 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    114 	for(fname in x) {
    115 		if(x[fname]) {
    116 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    117 			exit 3
    118 		}
    119 	}
    120 }' >.install-links.new
    121 mv .install-links.new .install-links